#include <SDL/SDL.h> 
#include <SDL/SDL_opengl.h>
#include "SDL_mixer.h"
#include <math.h>
#include <time.h>
#include <fstream>
#include <string>
#include <sstream>
#include <iostream>
#include <vector>
#include "glfont.c"
GLFONT *font;
using namespace std;
void SpecialKeys(int key, int x, int y);
void Mouse(int x, int y);
int extSupport(const char *extension);
int preDraw();
int postDraw();
int Init(int argc, char* argv[],char *windowname);
int Quit();
int Run();
void Render();
float dist=0;
GLuint fontID;
bool paused=0;
int boss=0;
int nBoss=0;
int score[2]={0,0};
int lives;
int td=1;
bool quit=0;
int highscore=0;

int timeBetweenEnemies=300;
float lifeBarRate=1;
int randomNumberSeed=0;
int powerUpAtMultipleOf=5000;

int timeBeforeBoss=50;
int bossRadius=55;
int bossMinSides=100;
int bossFireRate=30;
int maxBossBullets=80;
int bossStartingSatelites=3;
int distOfSatelitesfromBoss=150;
int sateliteRadius=30;
int sateliteFireRate=30;
int minSateliteSides=25;
int maxSateliteSides=50;
int maxSateliteBullets=25;
int chanceSatelitesAim=4;
int chanceSatelitesShootCircles=3;
int chanceSatelitesShootRockets=10;

int enemyMinRadius=25;
int enemyMaxAddedRadius=25;
int enemyMinSides=3;
int enemyMaxAddedSides=7;
int enemyMinFireRate=30;
int enemyMaxAddedFireRate=20;

int timeBeforeAimingEnemy=30;
int chanceOfAimingEnemy=5;
int aimingEnemyMinRadius=35;
int aimingEnemyMaxAddedRadius=15;
int aimingEnemyMinSides=7;
int aimingEnemyMaxAddedSides=10;
int aimingEnemyFireRate=10;
int aimingEnemyMinFireTime=15;
int aimingEnemyMaxAddedFireTime=30;

int timeBeforeCircleEnemy=50;
int chanceOfCircleEnemy=5;
int circleEnemyMinRadius=20;
int circleEnemyMaxAddedRadius=5;
int circleEnemyMinSides=5;
int circleEnemyMaxAddedSides=10;
int circleEnemyMinFireRate=10;
int circleEnemyMaxAddedFireRate=10;
int circleBulletRadius=5;

int timeBeforeChargingEnemy=70;
int chanceOfChargingEnemy=5;
int chargingEnemyMinRadius=15;
int chargingEnemyMaxAddedRadius=5;
int chargingEnemyMinSides=20;
int chargingEnemyMaxAddedSides=5;
int chargingEnemyMinRate=30;
int chargingEnemyMaxAddedRate=260;

int timeBeforeRocketEnemy=60;
int chanceOfRocketEnemy=8;
int rocketEnemyMinRadius=25;
int rocketEnemyMaxAddedRadius=25;
int rocketEnemyMinSides=3;
int rocketEnemyMaxAddedSides=7;
int rocketEnemyMinFireRate=60;
int rocketEnemyMaxAddedFireRate=20;		
int rocketSpeed=7;
int timeTillRocketExplodes=60;
int vsync=0;
bool powerup[2];
int poweruptype[2];
int powerupat[2];
Mix_Music *music;
Mix_Chunk *bam;
Mix_Chunk *gotpowerup;
Mix_Chunk *shoot[3];
Mix_Chunk *select;
bool sound=1;
void Savehighscore()
{
	FILE *fp=fopen("highscore.txt","w");
	fprintf(fp,"highscore: %i\n",highscore);
	fprintf(fp,"vsync: %i\n",vsync);
	fprintf(fp,"sound: %i\n",sound);
	fclose(fp);
	Mix_FreeMusic(music);
}
typedef struct
{
	float x,y;
} vec2f;
typedef struct
{
	union
	{
		float x;
		float u;
		float yaw;
		float r;
	};
	union
	{
		float y;
		float v;
		float pitch;
		float g;
	};
	union
	{
		float z;
		float w;
		float roll;
		float b;
	};
} vec3f;
typedef struct
{
	float x,y,z,w;
} vec4f;
typedef struct
{
	int x,y;
} vec2i;
typedef struct
{
	unsigned int x,y,z;
} vec3i;
typedef struct
{
	unsigned short x,y,z;
} vec3s;
float FPS;//actually ms per frame
float fpsm;//multiply by this to get framerate independent movement
int frames=0;
int start=0;
int width,height;
int hw,hh;
int qw,qh;
const float DEG2RAD=0.017453292519943295769236907684886;
float pd[500];//lookup table
bool cicle2Circle(float x1,float y1,float r1,float x2,float y2,float r2)
{
	float dist=(x2-x1)*(x2-x1)+(y2-y1)*(y2-y1);
	float r=r1*r1+r2+r2;
	if(dist<=r) return 1;
	return 0;
}
bool circle2Rectangle(float x,float y,float r,float minx,float miny,float maxx,float maxy)
{
	if( x+r>minx &&
		x-r<maxx &&
		y+r>miny &&
		y-r<maxy)
		return 1;
	return 0;
}
bool point2Circle(float x1,float y1,float r1,float x2,float y2)
{
	float dist=(x2-x1)*(x2-x1)+(y2-y1)*(y2-y1);
	float r=r1*r1;
	if(dist<=r) return 1;
	return 0;
}
bool point2Rectangle(float x,float y,float minx,float miny,float maxx,float maxy)
{
	if( x>minx &&
		x<maxx &&
		y>miny &&
		y<maxy)
		return 1;
	return 0;
}
float Sign(vec2f p1,vec2f p2,vec2f p3)
{
  return (p1.x - p3.x) * (p2.y - p3.y) - (p2.x - p3.x) * (p1.y - p3.y);
}

bool point2Triangle(vec2f pt,vec2f v1,vec2f v2,vec2f v3)
{
  bool b1, b2, b3;

  b1 = Sign(pt, v1, v2) < 0.0f;
  b2 = Sign(pt, v2, v3) < 0.0f;
  b3 = Sign(pt, v3, v1) < 0.0f;

  return ((b1 == b2) && (b2 == b3));
}

class Object
{
	public:
	int type;
	bool on;
	float x,y,r;
	float vx,vy;
	int data,data2,data4;
	float data3;
	bool dead;
	float flash;
	Object* next;
	Object* previous;
	Object(int X,int Y,float VX,float VY)
	{
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		dead=0;
		type=0;
		on=1;
	}
	Object()
	{
		dead=data=data2=data4=type=0;
		x=y=r=vx=vy=data3=flash=0;
	}
	virtual void update()=0;
	virtual void hit(Object *obj)=0;
};
Object * firstObject =NULL;
Object * lastObject =NULL;
int nObject=0;
class Animation;
class GameOver;
Object* AddObject(Object *obj)
{
	if(firstObject==NULL)
	{
		firstObject=obj;
		lastObject=firstObject;
	    lastObject->next=NULL;
	    lastObject->previous=NULL;
	}
	else
	{
	    lastObject->next=obj;
	    lastObject->next->previous=lastObject;
	    lastObject=lastObject->next;
	    lastObject->next=NULL;
	}
	lastObject->dead=false; 
	nObject++;
	return lastObject;
}
class LL//LL=linked list
{
public:
	Object *obj;
	LL* next;
};
class LLS
{
public:
	LL *first;
	LL *last;
	LLS()
	{
		first=last=NULL;
	}
	void Add(LL *ll)
	{
		if(first==NULL)
		{
			first=ll;
			last=first;
		    last->next=NULL;
		}
		else
		{
		    last->next=ll;
		    last=last->next;
		    last->next=NULL;
		}
	}
	void Clear()
	{
		LL* thisLL=first;
		LL* deadLL=NULL; //Seen these before
		while(thisLL!=NULL)
		{
			deadLL=thisLL; //Dead is the current node
			thisLL=thisLL->next; //Move thisLL forward
		    delete deadLL; //Delete dead
		}
		first=NULL; //Reset the head
		last=NULL; //And reset the tail
	}
};
#ifdef VERT
#define GW 4//collision grid
#define GH 5
#else
#define GW 5
#define GH 4
#endif
float CW;
float CH;
LLS grid[GW][GH];
void AddCircleToGrid(float x,float y,float r,Object *obj)
{
	for(int j=0;j<GH;j++)
		for(int i=0;i<GW;i++)
		{
			if(circle2Rectangle(x,y,r,i*CW-hw,j*CH-hh,(i+1)*CW-hw,(j+1)*CH-hh))
			{
				LL *ll=new LL();
				ll->obj=obj;
				grid[i][j].Add(ll);
			}
		}
}
void AddPointToGrid(float x,float y,Object *obj)
{
	for(int j=0;j<GH;j++)
		for(int i=0;i<GW;i++)
		{
			if(point2Rectangle(x,y,i*CW-hw,j*CH-hh,(i+1)*CW-hw,(j+1)*CH-hh))
			{
				LL *ll=new LL();
				ll->obj=obj;
				grid[i][j].Add(ll);
				return;
			}
		}
}
#define PBULLET 1
#define EBULLET 2
#define HBULLET 3
#define ENEMY 4
#define PLAYER 0
#define NO 0
#define P2C 1
#define C2P 2
#define C2C 3
#define T2P 4
#define P2T 5
void RemoveAnimation(int n);
void AddAnimation(Animation *anima);
void AddExplosion(float x,float y,int size,int length);
class Pbullet:public Object
{
	public:
	Pbullet()
	{
		data=2;
		type=PBULLET;
	}
	Pbullet(float X,float Y,float VX,float VY,int P)
	{
		data=2;
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		type=PBULLET;
		data4=P;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
		if(!dead) AddPointToGrid(x,y,this);
		glColor3f(0,.5,1);
		glBegin(GL_TRIANGLES);
			glVertex2f(x+vy*.5,y-vx*.5);
			glVertex2f(x-vy*.5,y+vx*.5);
			glVertex2f(x-vx*5,y-vy*5);
			glVertex2f(x+vy*.5,y-vx*.5);
			glVertex2f(x-vy*.5,y+vx*.5);
			glVertex2f(x+vx*.5,y+vy*.5);
		glEnd();
		glColor3f(0,0,0);
	}
	void hit(Object *obj)
	{
		dead=1;
	}
};
bool chargebullet[2]={0,0};
class PChargebullet:public Object
{
	public:
	PChargebullet()
	{
		data=-7;
		type=PBULLET;
	}
	PChargebullet(float X,float Y,float VX,float VY,int P,int Charge)
	{
		data=-7;
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		type=PBULLET;
		data4=P;
		data2=Charge;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
		glColor3f(1,1,1);
		glBegin(GL_TRIANGLES);
#ifdef VERT
			glVertex2f(x+data2/3,y);
			glVertex2f(x-data2/3,y);
			glVertex2f(x-vx*(data2/3),y-vy*(data2/3));
			glVertex2f(x+data2/3,y);
			glVertex2f(x-data2/3,y);
			glVertex2f(x,y+data2/3);
#else
			glVertex2f(x,y+data2/3);
			glVertex2f(x,y-data2/3);
			glVertex2f(x-vx*(data2/3),y-vy*(data2/3));
			glVertex2f(x,y+data2/3);
			glVertex2f(x,y-data2/3);
			glVertex2f(x+data2/3,y);
#endif
		glEnd();
		glColor3f(0,0,0);
		if(data2<1)
		{
			dead=1;
			chargebullet[data4]=0;
		}
		if(!dead) AddPointToGrid(x,y,this);
	}
	void hit(Object *obj)
	{	
	}
};
class Ebullet:public Object
{
	public:
	Ebullet()
	{
		data=2;
		type=EBULLET;
	}
	Ebullet(float X,float Y,float VX,float VY)
	{
		data=2;
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		type=EBULLET;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
		if(!dead) AddPointToGrid(x,y,this);
		glColor3f(1,0,0);
			glBegin(GL_TRIANGLES);
				glVertex2f(x+vy,y-vx);
				glVertex2f(x-vy,y+vx);
				glVertex2f(x-vx*13,y-vy*13);
				glVertex2f(x+vy,y-vx);
				glVertex2f(x-vy,y+vx);
				glVertex2f(x+vx,y+vy);
			glEnd();
		glColor3f(0,0,0);
	}
	void hit(Object *obj)
	{
		dead=1;
	}
};
class EbulletBig:public Object
{
	public:
	float rot;
	EbulletBig()
	{
		data=-2;
		rot=0;
		type=ENEMY;
		r=5;
	}
	EbulletBig(float X,float Y,float VX,float VY)
	{
		data=-2;
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		type=ENEMY;
		rot=0;
		r=circleBulletRadius;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
#ifdef VERT
		if(y+r<-hh || x-r>hw || x+r<-hw) dead=1;
#else
		if(y+r<-hh || y-r>hh || x+r<-hw) dead=1;
#endif
		if(!dead) AddCircleToGrid(x,y,r,this);
		glColor3f(1,0,0);
		glLineWidth(3);
			glBegin(GL_LINE_LOOP);
				for(int i=0;i<=8;i++)
				{
					glVertex2f((cos(pd[8]*i+rot)*r)+x,(sin(pd[8]*i+rot)*r)+y);
				}
			glEnd();
		glLineWidth(1.1);
		rot+=.1*fpsm;
		glColor3f(0,0,0);
	}
	void hit(Object *obj)
	{
	}
};

class Player:public Object
{
	public:
	float rot;
	float roll;
	float fireat;
	float R;
	int i;
	int p;
	int level[3];
	int gun;
	Object *obj;
	float d;
	Player()
	{
#ifdef VERT
		x=0;
		y=-200;
#else
		x=-200;
		y=0;
#endif
		r=15;
		data=0;
		type=PLAYER;
		lives=5;
		flash=0;
		p=0;
		level[0]=level[1]=level[2]=0;
		gun=0;
	}
	void update();
	void hit(Object *obj);
};
Player *player,*player2;
int nBoom=0;
class Animation
{
public:
	int n;
	virtual void update()=0;
};
Animation *anim[5];
int nAnim=0;
void AddAnimation(Animation *anima)
{
	anim[nAnim]=anima;
	anim[nAnim]->n=nAnim;
	nAnim++;
}
void RemoveAnimation(int n)
{
	for(int i=n;i<4;i++)
		anim[i]=anim[i+1];
	nAnim--;
}
bool boomPlayed=0;
class Menu:public Animation
{
public:
	int option;
	float rot;
	float x,y;
	float vx,vy;
	float dist;
	bool h;
	bool v;//keys are sometimes help too long, so this will wait until key is released before letting it be reset again
	bool s;
	Menu()
	{
		option=0;
		rot=0;
		x=-120;
		y=-15;
		vx=-120;
		vy=-15;
		h=0;
		v=0;
		s=0;
	}
	void update()
	{
		Uint8 * keystate=SDL_GetKeyState(NULL);
		if(keystate[SDLK_z]||keystate[SDLK_SLASH])
		{
			Object* thisObject=firstObject;
			if(h)
			switch(option)
			{
				case 0:
					while(thisObject!=NULL)
					{
						thisObject->dead=1;
						thisObject=thisObject->next;
					}
					boss=0;
					nBoss=0;
					td=0;
					lives=5;
					player=new Player();
					AddObject(player);
					player2=NULL;
					RemoveAnimation(n);
					score[0]=0;
					break;
				case 1:
					while(thisObject!=NULL)
					{
						thisObject->dead=1;
						thisObject=thisObject->next;
					}
					boss=0;
					nBoss=0;
					td=0;
					lives=10;
					player=new Player();
#ifdef VERT
					player->x=150;
#else
					player->y=200;
#endif
					AddObject(player);
					player2=new Player();
					player2->p=1;
#ifdef VERT
					player2->x=-150;
#else
					player2->y=-200;
#endif
					AddObject(player2);
					RemoveAnimation(n);
					score[0]=0;
					score[1]=0;
					break;
				case 2:
					quit=1;
					break;
			}
		}
		else h=1;
		if(keystate[SDLK_UP] && fabs(vx-x)<1 && fabs(vy-y)<1)
		{
			switch(option)
			{
				case 0:
					vx=-45;
					vy=-115;
					break;
				case 1:
					vx=-120;
					vy=-15;
					break;
				case 2:
					vx=-120;
					vy=-65;
					break;
			}
			option--;
			if(option<0) option=2;
			Mix_PlayChannel(-1,select,0);
		}
		else if(keystate[SDLK_DOWN] && fabs(vx-x)<1 && fabs(vy-y)<1)
		{
			switch(option)
			{
				case 0:
					vx=-120;
					vy=-65;
					break;
				case 1:
					vx=-45;
					vy=-115;
					break;
				case 2:
					vx=-120;
					vy=-15;
					break;
			}
			option++;
			if(option>2) option=0;
			Mix_PlayChannel(-1,select,0);
		}
		if(keystate[SDLK_r])
			highscore=0;
		if(keystate[SDLK_v])
		{
			if(v==0)
				if(vsync==1)
					vsync=0;
				else
					vsync=1;
			v=1;
		}
		else v=0;
		if(keystate[SDLK_s])
		{
			if(s==0)
			{
				if(Mix_VolumeMusic(-1)==0)
					sound=1;
				else
					sound=0;
			}
			s=1;
			if(sound)
			{
				Mix_Volume(-1, MIX_MAX_VOLUME/2);
				Mix_VolumeMusic(MIX_MAX_VOLUME);
			}
			else
			{
				Mix_Volume(-1, 0);
				Mix_VolumeMusic(0);
			}
		}
		else s=0;
		glFontBegin(font);
		glPushMatrix();
		glTranslatef(0,qh+20,50);
		glScalef(60,60,1);
		glFontTextOutc("ZALLAN");
		glFontEnd();
		glFontBegin(font);
		glPopMatrix();
		glPushMatrix();
		glTranslatef(0,0,50);
		glScalef(15,15,1);
		glFontTextOutc("1 PLAYER START");
		glFontEnd();
		glFontBegin(font);
		glPopMatrix();
		glPushMatrix();
		glTranslatef(0,-50,50);
		glScalef(15,15,1);
		glFontTextOutc("2 PLAYER START");
		glFontEnd();
		glFontBegin(font);
		glPopMatrix();
		glPushMatrix();
		glTranslatef(0,-100,50);
		glScalef(15,15,1);
		glFontTextOutc("EXIT");
		glFontEnd();
		glPopMatrix();
		glPushMatrix();
		glTranslatef(x,y,50);	
		glRotatef(rot,1,0,0);
		glBegin(GL_TRIANGLES);
			glVertex2f(10,0);
			glVertex2f(-8,-7);
			glVertex2f(-8,7);
		glEnd();
		glTranslatef(-2*x,0,0);
		glScalef(-1,1,1);
		glBegin(GL_TRIANGLES);
			glVertex2f(10,0);
			glVertex2f(-8,-7);
			glVertex2f(-8,7);
		glEnd();
		glPopMatrix();
		glPushMatrix();
		glFontBegin(font);
		glTranslatef(0,-hh+40,50);
		glScalef(6,6,1);
		glFontTextOutc("RESET HIGHSCORE: R     TOGGLE V-SYNC: V  (REQUIRES RESTART)");
		glFontEnd();
		glPopMatrix();
		rot+=3.5*fpsm;
		for(int i=0;i<5;i++)
		{
			if(x<vx-.001) x+=fpsm;
			else if(x+.001>vx) x-=fpsm;
			if(y<vy-.001) y+=fpsm;
			else if(y+.001>vy) y-=fpsm;
		}
	}
};
class GameOver:public Animation
{
public:
	bool h;
	GameOver()
	{
		h=0;
		player->data=0;
	}
	void update()
	{
		Uint8 * keystate=SDL_GetKeyState(NULL);
		if((keystate[SDLK_z]||keystate[SDLK_SLASH]||keystate[SDLK_b]))
		{
			if(h)
			{
				Menu *menu=new Menu();
				AddAnimation(menu);
				RemoveAnimation(n);
			}
		}
		else h=1;
		glFontBegin(font);
		glPushMatrix();
		glScalef(15,15,1);
		glFontTextOutc("GAME OVER");
		glFontEnd();
		glPopMatrix();
		glPushMatrix();
		glFontBegin(font);
		glTranslatef(0,-50,0);
		glScalef(10,10,1);
		glFontTextOutc("PRESS FIRE");
		glFontEnd();
		glPopMatrix();
		if(player2!=NULL)
		{
			glPushMatrix();
			glFontBegin(font);
			glTranslatef(0,-80,0);
			glScalef(9,9,1);
			if(score[0]>score[1])
				glFontTextOutc("PLAYER 1 WINS!");
			else if(score[0]<score[1])
				glFontTextOutc("PLAYER 2 WINS!");
			else
				glFontTextOutc("DRAW!");	
			glFontEnd();
			glPopMatrix();
		}
	}
};
class Life:public Animation
{
public:
	float time;
	Life() { time=200; }
	void update()
	{
		glPushMatrix();
		glTranslatef(0,0,6);
		glBegin(GL_TRIANGLE_STRIP);
			glColor3f(.1,1,.2);
			glVertex2f(-hw+2,-hh+2);
			glVertex2f(-hw+17,-hh+2);
			glVertex2f(-hw+2,-hh+2+time);
			glVertex2f(-hw+17,-hh+2+time);
		glEnd();
		glPopMatrix();
		time-=2.3*fpsm;
		if(time<=0)
			RemoveAnimation(n);
	}
};

class Explosion
{
	public:
	float x,y;
	float time;
	bool valid;
	Explosion()
	{
		x=y=time=valid=0;
	}
	void reset(float X,float Y,float Time)
	{
		x=X;
		y=Y;
		time=Time;
		valid=1;
	}
	void update()
	{
		if(!valid) return;
		if(time>1)
		{
			time-=.025*fpsm;
			return;
		}
		glColor4f(1,time,0,time+.5);
		glBegin(GL_TRIANGLE_STRIP);
			glVertex3f(x-4,y-4,time+.5);
			glVertex3f(x-4,y+4,time+.5);
			glVertex3f(x+4,y-4,time+.5);
			glVertex3f(x+4,y+4,time+.5);
		glEnd();
		time-=.025*fpsm;
		if(time<-.5) valid=0;
	}
};
#define MAX_BOOM 15000
Explosion boom[MAX_BOOM];
int AddBoom(float X,float Y,float Time)
{
	for(int i=0;i<MAX_BOOM;i++)
	{
		if(!boom[i].valid)
		{
			boom[i].reset(X,Y,Time);
			return 1;
		}
	}
	return 0;
}
void AddExplosion(float x,float y,float size,int length)
{
	for(int i=0;i<size*10;i++)
	{
		float dir=rand()%640*.01;
		float dist=rand()%(int)(size+1);
		if(!AddBoom(cos(dir)*dist+x,sin(dir)*dist+y,rand()%length*.001)) return;
	}
	Mix_PlayChannel(-1,bam,0);
}
class PowerUp:public Object
{
	public:
	PowerUp()
	{
		data=-5;
		type=ENEMY;
		r=5;
	}
	PowerUp(float X,float Y,int Type)
	{
		data=-5;
		x=X;
		y=Y;
		type=ENEMY;
		r=6;
		data2=Type;
	}
	void update()
	{
#ifdef VERT
		y-=2*fpsm;
#else
		x-=2*fpsm;
#endif
		if(!dead) AddPointToGrid(x,y,this);
		switch(data2)
		{
			case 0:
				glColor3f(0,.5,1);
				break;
			case 1:
				glColor3f(1,1,1);
				break;
			case 2:
				glColor3f(1,1,0);
				break;
		}
		glLineWidth(3.5);
		glBegin(GL_LINE_LOOP);
		for(int i=0;i<3;i++)
			glVertex2f((cos(pd[3]*i+data3)*r)+x,(sin(pd[3]*i+data3)*r)+y);
		glEnd();
		glColor3f(0,0,0);
		glLineWidth(1.1);
		data3+=.05*fpsm;
	}
	void hit(Object *obj)
	{
	}
};
void Powerup(float x,float y)
{
	if(score[0]>=powerupat[0])
	{
		PowerUp *pwr=new PowerUp(x,y,rand()%3);
		powerupat[0]=score[0]+powerUpAtMultipleOf;
		AddObject(pwr);
	}
	if(score[1]>=powerupat[1])
	{
		PowerUp *pwr=new PowerUp(x,y,rand()%3);
		powerupat[1]=score[1]+powerUpAtMultipleOf;
		AddObject(pwr);
	}
}
class ERocket:public Object
{
	public:
	float ax,ay;
	float time;
	ERocket()
	{
		data=-2;
		time=0;
		type=ENEMY;
		r=5;
	}
	ERocket(float X,float Y)
	{
		data=-2;
		x=X;
		y=Y;
		if(player!=NULL)
		{
			float w=player->x-x;
			float h=player->y-y;
			float a=atan2(h,w);
			ax=cos(a);
			ay=sin(a);
		}
		else
		{
			float w=20-x;
			float h=-130-y;
			float a=atan2(h,w);
			ax=cos(a+rand()%2-1);
			ay=sin(a+rand()%2-1);
		}
		vx=ax;
		vy=ay;
		type=ENEMY;
		time=0;
		r=5;
	}
	void update()
	{
		if(player!=NULL)
		{
			float w=player->x-x;
			float h=player->y-y;
			float a=atan2(h,w);
			ax=cos(a);
			ay=sin(a);
		}
		else
		{
			float w=rand()%(int)width-hw;
			float h=rand()%(int)height-hh;;
			float a=atan2(h,w);
			ax=cos(a);
			ay=sin(a);
		}
		vx+=ax*fpsm;
		vy+=ay*fpsm;
		x+=vx*fpsm;
		y+=vy*fpsm;
		float l=sqrt(vx*vx+vy*vy);
		vx=vx/l*rocketSpeed;
		vy=vy/l*rocketSpeed;
		if(y-r>hh || y+r<-hh || x-r>hw || x+r<-hw) dead=1;
		glColor3f(1,0,0);
			glBegin(GL_TRIANGLES);
				glVertex2f(x-ay*5,y+ax*5);
				glVertex2f(x+ay*5,y-ax*5);
				glVertex2f(x+ax*5,y+ay*5);
			glEnd();
		AddBoom(x-ax+rand()%60*.1-3,y-ay+rand()%60*.1-3,(rand()%600+650)*.001);
		time+=fpsm;
		if(time>timeTillRocketExplodes)
		{
			AddExplosion(x+vx,y+vy,r*2,1000);
			AddExplosion(x+vx*3,y+vy*3,r*3,1000);
			AddExplosion(x+vx*5,y+vy*5,r*4,1000);
			dead=1;
		}
		glColor3f(0,0,0);
		if(!dead) AddCircleToGrid(x,y,r,this);
	}
	void hit(Object *obj)
	{
		time=timeTillRocketExplodes+1;
	}
};
void Player::update()
{
	if(flash<110)
	{
		Uint8 * keystate=SDL_GetKeyState(NULL);
		if(lives<0)
		{
			if(p==0)
			{
				GameOver *gm=new GameOver();
				AddAnimation(gm);
			}
			dead=1;
		}
		if(p==0)
		{
			if(keystate[SDLK_UP])
			{
				y+=5*fpsm;
#ifndef VERT
				roll=10;
#endif
			}
			else
			if(keystate[SDLK_DOWN])
			{
				y-=5*fpsm;
#ifndef VERT
				roll=-10;
#endif
			}
#ifndef VERT
			else
				roll=0;
#endif
			if(keystate[SDLK_RIGHT])
			{
				x+=5*fpsm;
#ifdef VERT
				roll=10;
#endif
			}
			else
			if(keystate[SDLK_LEFT])
			{
				x-=5*fpsm;
#ifdef VERT
				roll=-10;
#endif
			}
#ifdef VERT
			else
				roll=0;
#endif
			d=40000+level[gun]*10000;
			float dist;
			switch(gun)
			{
				case -1: 
					gun=3;
					break;
				case 0:
					if((keystate[SDLK_z]&&player2==NULL)||(keystate[SDLK_SLASH]))
					{
						if(fireat>5)
						{
							Pbullet *bullet;
							Pbullet *bullet2;
							Pbullet *bullet3;
							switch(level[gun])
							{
								case 0:
#ifdef VERT
									bullet=new Pbullet(x,y+25,0,6,p);
									AddObject(bullet);
									break;
								case 1:
									bullet=new Pbullet(x-7,y+15,0,6,p);
									AddObject(bullet);
									bullet2=new Pbullet(x+7,y+15,0,6,p);
									AddObject(bullet2);
									break;
								case 2:
									bullet3=new Pbullet(x,y+25,0,6,p);
									AddObject(bullet3);
									bullet=new Pbullet(x-7,y+15,0,6,p);
									AddObject(bullet);
									bullet2=new Pbullet(x+7,y+15,0,6,p);
									AddObject(bullet2);
#else
									bullet=new Pbullet(x+25,y,6,0,p);
									AddObject(bullet);
									break;
								case 1:
									bullet=new Pbullet(x+15,y-7,6,0,p);
									AddObject(bullet);
									bullet2=new Pbullet(x+15,y+7,6,0,p);
									AddObject(bullet2);
									break;
								case 2:
									bullet3=new Pbullet(x+25,y,6,0,p);
									AddObject(bullet3);
									bullet=new Pbullet(x+15,y-7,6,0,p);
									AddObject(bullet);
									bullet2=new Pbullet(x+15,y+7,6,0,p);
									AddObject(bullet2);
#endif
									break;
							}
							fireat=0;
							Mix_PlayChannel(-1,shoot[0],0);
						}
						fireat+=fpsm;
					}
					else fireat=6;
					break;
				case 1:
					if((keystate[SDLK_z]&&player2==NULL)||(keystate[SDLK_SLASH]) && !chargebullet[p])
					{
						if(fireat<15+level[gun]*2)
							fireat+=fpsm*0.2*(level[gun]);
					}
					else if(fireat>0 && !chargebullet[p])
					{
#ifdef VERT
						PChargebullet *bullet=new PChargebullet(x,y+30,0,6,p,(int)fireat);
#else
						PChargebullet *bullet=new PChargebullet(x+30,y,6,0,p,(int)fireat);
#endif
						AddObject(bullet);
						fireat=0;
						chargebullet[p]=1;
						Mix_PlayChannel(-1,shoot[1],0);
					}
					break;
				case 2:
					if(fireat>=0)
					{
						if((keystate[SDLK_z] && player2==NULL)||(keystate[SDLK_SLASH]))
						{
							Object* thisObject=firstObject;
							obj=NULL;
							while(thisObject!=NULL)
							{
#ifdef VERT
								if(thisObject->type==ENEMY && thisObject->data!=-2 && thisObject->data!=-5 && thisObject->y<hh)
#else
								if(thisObject->type==ENEMY && thisObject->data!=-2 && thisObject->data!=-5 && thisObject->x<hw)
#endif
								{
									dist=(x-thisObject->x)*(x-thisObject->x)+(y-thisObject->y)*(y-thisObject->y)-thisObject->r*thisObject->r;
									if(dist<d)
									{
										d=dist;
										obj=thisObject;
									}
								}
								thisObject=thisObject->next;
							}
							fireat=1;
							if(d>39999+level[gun]*10000 || obj==this)
								obj=NULL;
						}
						else
						{
							fireat=0;
							obj=NULL;
						}
					}
					else fireat+=fpsm;
					break;
				case 3:
					gun=0;
					break;
			}
		}
		else
		{
			if(keystate[SDLK_w])
			{
				y+=5*fpsm;
#ifndef VERT
				roll=10;
#endif
			}
			else
			if(keystate[SDLK_s])
			{
				y-=5*fpsm;
#ifndef VERT
				roll=-10;
#endif
			}
#ifndef VERT
			else
				roll=0;
#endif
			if(keystate[SDLK_d])
			{
				x+=5*fpsm;
#ifdef VERT
				roll=10;
#endif
			}
			else
			if(keystate[SDLK_a])
			{
				x-=5*fpsm;
#ifdef VERT
				roll=-10;
#endif
			}
#ifdef VERT
			else
				roll=0;
#endif
			d=40000+level[gun]*10000;
			float dist;
			switch(gun)
			{
				case -1: 
					gun=3;
					break;
				case 0:
					if((keystate[SDLK_b]))
					{
						if(fireat>5)
						{
							Pbullet *bullet;
							Pbullet *bullet2;
							Pbullet *bullet3;
							switch(level[gun])
							{
								case 0:
#ifdef VERT
									bullet=new Pbullet(x,y+25,0,6,p);
									AddObject(bullet);
									break;
								case 1:
									bullet=new Pbullet(x-7,y+15,0,6,p);
									AddObject(bullet);
									bullet2=new Pbullet(x+7,y+15,0,6,p);
									AddObject(bullet2);
									break;
								case 2:
									bullet3=new Pbullet(x,y+25,0,6,p);
									AddObject(bullet3);
									bullet=new Pbullet(x-7,y+15,0,6,p);
									AddObject(bullet);
									bullet2=new Pbullet(x+7,y+15,0,6,p);
									AddObject(bullet2);
#else
									bullet=new Pbullet(x+25,y,6,0,p);
									AddObject(bullet);
									break;
								case 1:
									bullet=new Pbullet(x+15,y-7,6,0,p);
									AddObject(bullet);
									bullet2=new Pbullet(x+15,y+7,6,0,p);
									AddObject(bullet2);
									break;
								case 2:
									bullet3=new Pbullet(x+25,y,6,0,p);
									AddObject(bullet3);
									bullet=new Pbullet(x+15,y-7,6,0,p);
									AddObject(bullet);
									bullet2=new Pbullet(x+15,y+7,6,0,p);
									AddObject(bullet2);
#endif
									break;
							}
							fireat=0;
						}
						fireat+=fpsm;
					}
					else fireat=6;
					break;
				case 1:
					if((keystate[SDLK_b]) && !chargebullet[p])
					{
						if(fireat<15+level[gun]*2)
							fireat+=fpsm*0.2*(level[gun]);
					}
					else if(fireat>0 && !chargebullet[p])
					{
#ifdef VERT
						PChargebullet *bullet=new PChargebullet(x,y+30,0,6,p,(int)fireat);
#else
						PChargebullet *bullet=new PChargebullet(x+30,y,6,0,p,(int)fireat);
#endif
						AddObject(bullet);
						fireat=0;
						chargebullet[p]=1;
					}
					break;
				case 2:
					if(fireat>=0)
					{
						if((keystate[SDLK_b]))
						{
							Object* thisObject=firstObject;
							obj=NULL;
							while(thisObject!=NULL)
							{
#ifdef VERT
								if(thisObject->type==ENEMY && thisObject->data!=-2 && thisObject->data!=-5 && thisObject->y<hh)
#else
								if(thisObject->type==ENEMY && thisObject->data!=-2 && thisObject->data!=-5 && thisObject->x<hw)
#endif
								{
									dist=(x-thisObject->x)*(x-thisObject->x)+(y-thisObject->y)*(y-thisObject->y)-thisObject->r*thisObject->r;
									if(dist<d)
									{
										d=dist;
										obj=thisObject;
									}
								}
								thisObject=thisObject->next;
							}
							fireat=1;
							if(d>39999+level[gun]*10000 || obj==this)
								obj=NULL;
						}
						else
						{
							fireat=0;
							obj=NULL;
						}
					}
					else fireat+=fpsm;
					break;
				case 3:
					gun=0;
					break;
			}
		}
		if(x+r>hw) x=hw-r;
		else if(x-r<-hw) x=-hw+r;
		if(y+r>hh) y=hh-r;
		else if(y-r<-hh) y=-hh+r;
	}
	else if(flash>120)
	{	
		if(i%10==0)
		{
#ifdef VERT
			AddExplosion(x,y-(i/3),R,1800-i*2);
#else
			AddExplosion(x-(i/3),y,R,1800-i*2);
#endif
			R-=.75*fpsm;
		}
		i+=15*fpsm;
	}
	glDisable(GL_BLEND);
	if(flash>=.1)
	{
		on=!on;
	}
	else on=1;
	if(on)
	{
		if(p==0)
			glColor3f(.7,.7,.7);
		else
			glColor3f(.5,.5,.5);
		glPushMatrix();
#ifdef VERT
		glRotatef(roll,0,1,0);
#else
		glRotatef(roll,1,0,0);
#endif
		glTranslatef(x,y,1);
		glBegin(GL_TRIANGLES);
#ifdef VERT
			glVertex2f(0,10);
			glVertex2f(-7,-8);
			glVertex2f(7,-8);
#else
			glVertex2f(10,0);
			glVertex2f(-8,-7);
			glVertex2f(-8,7);
#endif				
		glEnd();
		if(gun==1 && fireat>0)
		{
			glColor3f(1,1,1);
			glBegin(GL_TRIANGLE_FAN);
#ifdef VERT
				glVertex2f(0,13);
#else
				glVertex2f(13,0);
#endif
				for(i=0;i<=8;i++)
				{
#ifdef VERT
					glVertex2f((cos(pd[8]*i)*(fireat/3+rand()%2-1)),(sin(pd[8]*i)*(fireat/3+rand()%2-1))+11);
#else
					glVertex2f((cos(pd[8]*i)*(fireat/3+rand()%2-1))+11,(sin(pd[8]*i)*(fireat/3+rand()%2-1)));
#endif
				}
			glEnd();
		}
		glPopMatrix();
		if(gun==2)
		{
			if(obj!=NULL)
			{
				glColor3f(1,1,0);
				glTranslatef(0,0,.7);
				float A=atan2(obj->y-y,obj->x-x);
				float a=A;
				float X=x,Y=y;
				float D=sqrt((obj->x-x)*(obj->x-x)+(obj->y-y)*(obj->y-y));
				glBegin(GL_LINES);
					for(int i=0;i<D;i+=5)
					{
						glVertex2f(X,Y);
						glVertex2f(X+cos(a)*5,Y+sin(a)*5);
						X+=cos(a)*5;
						Y+=sin(a)*5;
						if(a<A) a+=rand()%10*.1;
						else a-=rand()%10*.1;
					}
					glVertex2f(obj->x,obj->y);
				glEnd();
				if(fireat>.5)
				{
					Pbullet *bul=new Pbullet(obj->x,obj->y,0,0,p);
					obj->hit(bul);
					fireat=-7/(level[gun]+1);
							Mix_PlayChannel(-1,shoot[2],0);
					if(obj->data<3)
						obj=NULL;
				}
			}
			glPushMatrix();
			glTranslatef(x,y,.4);
			glColor3f(.7,.7,0);
				glBegin(GL_POINTS);
					for(i=0;i<=48;i++)
					{
						glVertex2f((cos(pd[48]*i)*(200+level[gun]*23)),(sin(pd[48]*i)*(200+level[gun]*23)));
					}
				glEnd();
			glPopMatrix();
		}
	}
	glEnable(GL_BLEND);
	glColor3f(0,0,0);
	if(flash>=.1)
		flash-=fpsm;
	if(!dead) AddCircleToGrid(x,y,r,this);
}
void Player::hit(Object *obj)
{
	Uint8 * keystate=SDL_GetKeyState(NULL);
	switch(obj->type)
	{
		case HBULLET:
			data+=lifeBarRate;
			if(data>200)
			{
				data=0;
				lives++;
				Life *life=new Life();
				AddAnimation(life);
			}	
			obj->dead=1;
			break;
		case ENEMY:
			if(obj->data<-2)
			{
				gun=obj->data2;
				level[gun]++;
				if(level[gun]>2)
					level[gun]=2;
				fireat=0;
				obj->dead=1;
				obj=NULL;
				Mix_PlayChannel(-1,gotpowerup,0);
				return;
			}
		case EBULLET:
			if(flash<.1 && !keystate[SDLK_c])
			{
				lives--;
				gun=0;
				level[0]=level[1]=level[2]=0;
				flash=175;
				R=r;
				i=0;
				AddExplosion(15+lives*16-hw,hh-35,(float)13,1100);
			}
			break;
	}
}			
int collisiontable[5][5]={
	NO,NO,T2P,T2P,C2C,
	NO,NO,NO,NO,P2C,
	P2T,NO,NO,NO,NO,
	P2T,NO,NO,NO,NO,
	C2C,C2P,NO,NO,NO,
};
bool blur=1;


class Health:public Object
{
	public:
	int on;
	Health()
	{
		data=4;
		type=HBULLET;
		r=5;
	}
	Health(float X,float Y,float VX,float VY)
	{
		data=4;
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		type=HBULLET;
		r=4;
		on=0;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
#ifdef VERT
		if(vx>0)
			vx-=fpsm*.01;
		else
			vx+=fpsm*.01;
#else
		if(vy>0)
			vy-=fpsm*.01;
		else
			vy+=fpsm*.01;
#endif
		if(fabs(vx)>.01 && fabs(vy)>.1)
		{
#ifdef VERT
			if(vy>0)
				vy-=fpsm*.01;
			else
				vy+=fpsm*.01;
#else
			if(vx>0)
				vx-=fpsm*.01;
			else
				vx+=fpsm*.01;
#endif
		}
		else
		{
#ifdef VERT
			if(vy>-1)
				vy-=fpsm*.02;
			if(vy<-1)
				vy+=fpsm*.02;
#else
			if(vx>-1)
				vx-=fpsm*.02;
			if(vx<-1)
				vx+=fpsm*.02;
#endif
		}
#ifdef VERT
		if(x+r>hw || x-r<-hw)
			vx=-vx;
		if(y+r>hh)
			vy=-vy;
#else
		if(y+r>hh || y-r<-hh)
			vy=-vy;
		if(x+r>hw)
			vx=-vx;
#endif
		if(player!=NULL)
		{
			if(!on)
			{
				float dist=(x-player->x)*(x-player->x)+(y-player->y)*(y-player->y);
				if(dist<2000)
				{
					on=1;
				}
				else
				if(player2!=NULL)
				{
					dist=(x-player2->x)*(x-player2->x)+(y-player2->y)*(y-player2->y);
					if(dist<2000)
					{
						on=2;
					}
				}
			}
			else if(on==1)
			{
				float w=player->x-x;
				float h=player->y-y;
				float a=atan2(h,w);
				vx=cos(a)*10;
				vy=sin(a)*10;
			}	
			else
			{
				float w=player2->x-x;
				float h=player2->y-y;
				float a=atan2(h,w);
				vx=cos(a)*10;
				vy=sin(a)*10;
			}	
		}
		glColor3f(.1,1,.2);
		glBegin(GL_LINE_LOOP);
		for(int i=0;i<4;i++)
			glVertex2f((cos(pd[4]*i+data3)*r)+x,(sin(pd[4]*i+data3)*r)+y);
		glEnd();
		glColor3f(0,0,0);
		data3+=.5*fpsm;
		if(!dead) AddPointToGrid(x,y,this);
	}
	void hit(Object *obj)
	{
		dead=1;
	}
};
int nBoss2=0;
class Boss:public Object
{
	public:
	float fireat;
	float rot;
	int dir;
	float time;
	Boss()
	{
#ifdef VERT
		x=0;
		y=600;
		vx=0;
		vy=-.6;
#else
		x=600;
		y=0;
		vx=-.6;
		vy=0;
#endif
		data=3;
		data2=25;
		data3=.03;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		time=-1000;
		dir=rand()%2;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
#ifdef VERT
		if(y<qh) vy=0;
#else
		if(x<qw) vx=0;
#endif
		int i;
		float c=1;//(data2-10)/20;
		if(data<3)
		{
			if(data==0)
			{
				dead=1;
				for(i=0;i<100;i++)
				{
					Health *bul=new Health((cos(pd[100]*i)*r)+x,(sin(pd[100]*i)*r)+y,cos(pd[100]*i)*0,sin(pd[100]*i)*0);
					AddObject(bul);
					if(i%4==0)
					{
						Ebullet *bul2=new Ebullet((cos(pd[100]*i+rot)*r)+x,(sin(pd[100]*i+rot)*r)+y,cos(pd[100]*i+rot)*2,sin(pd[100]*i+rot)*2);
						AddObject(bul2);
					}
				}
				nBoss++;
				AddExplosion(x,y,r+r,3000);
				score[0]+=10000;
				Powerup(x+1,y+1);
			}
			else
			{
				if(blur)
					glDisable(GL_BLEND);
				else
					glEnable(GL_BLEND);
				glPushMatrix();
				glTranslatef(x,y,.6);
				glColor3f(c,0,0);
					glBegin(GL_TRIANGLE_FAN);
						glVertex2f(0,0);
						for(i=0;i<=data;i++)
						{
							glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
						}
					glEnd();
				glPopMatrix();
				if(blur)
					glEnable(GL_BLEND);
				else
					glDisable(GL_BLEND);
				AddExplosion(x+cos(rand()%64*.1)*(r/4*3),y+sin(rand()%64*.1)*(r/4*3),r/2,2000);
				data--;
				rot+=data3*fpsm;
			}
			return;
		}
		if(blur)
			glDisable(GL_BLEND);
		else
			glEnable(GL_BLEND);
		glPushMatrix();
		glTranslatef(x,y,.6);
		glColor3f(c,0,0);
		if(nBoss2>0) r-=15;
			glBegin(GL_TRIANGLE_FAN);
				glVertex2f(0,0);
				for(i=0;i<=data;i++)
				{
					glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
				}
			glEnd();
		if(nBoss2>0) r+=15;
		glPopMatrix();
		if(nBoss2<=0)
		{
			if(fireat>data2)
			{
				for(i=0;i<data4;i++)
				{
					Ebullet *bul=new Ebullet((cos(pd[data4]*i+rot+data3*1.5)*r)+x+vx,(sin(pd[data4]*i+rot+data3*1.5)*r)+y+vy,(cos(pd[data4]*i+rot+data3))*1.5,sin(pd[data4]*i+rot+data3)*1.5);
					AddObject(bul);
				}
				fireat=0;
			}
			else fireat+=fpsm;
		}
		else
			{
				glColor3f(c,.3,.3);
				glPushMatrix();
				glTranslatef(x,y,.6);
					glBegin(GL_LINE_LOOP);
						glVertex2f(0,0);
						for(i=0;i<=data;i++)
						{
							glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
						}
					glEnd();
				glPopMatrix();
			}
		rot+=data3*fpsm;
		time+=fpsm;
		if(player==NULL && time>90)
			data=2;
		glColor3f(0,0,0);
		if(flash>=.1)
			flash-=fpsm;
		if(blur)
			glEnable(GL_BLEND);
		else
			glDisable(GL_BLEND);
		if(!dead) AddCircleToGrid(x,y,r,this);
	}
	void hit(Object *obj)
	{
		if(flash<.1 && nBoss2<=0)
		{
			if(obj->type==PBULLET)
			{
				if(obj->data==-7)
				{
					if(obj->data2>data)
					{
						obj->data2-=data;
						data=0;
					}
					else
					{
						data-=obj->data2;
						obj->data2=0;
					}
				}
				else
				{
					data--;
					obj->dead=1;
				}
				flash=5;
				score[obj->data4]+=500;
			}	
		}
		else if(obj->type==PBULLET && obj->data!=-7) obj->dead=1;
	}
		
};
Boss *BOSS;
void UpdateObjects()
{
	Object* thisObject=firstObject;
	Object* deadObject=NULL;
	while(thisObject!=NULL)
	{
	    if(thisObject->dead || (thisObject->type!=ENEMY && (thisObject->x<-hw || thisObject->x>hw || thisObject->y<-hh || thisObject->y>hh)))
	    {
			{
			nObject--;
			deadObject=thisObject;
			thisObject=thisObject->next;
			if(firstObject==deadObject)
			{
		        firstObject=thisObject;
		        if(thisObject!=NULL)
		        {
					thisObject->previous=NULL;
		        }
			}
			else
			{
				deadObject->previous->next=thisObject;
				if(thisObject!=NULL)
				{
					thisObject->previous=deadObject->previous;
				}
			}
			if(lastObject==deadObject)
			{
				lastObject=deadObject->previous;
			}
			if(deadObject==BOSS)
				BOSS=NULL;
			if(deadObject->data=-5)
				chargebullet[deadObject->data4]=0;
			delete deadObject;
			}
	    }
	    else
	    {
			thisObject->update();
			thisObject=thisObject->next;
	    }
	}
}

class BossEnemy:public Object
{
	public:
	float fireat;
	float rot,rot2;
	float r2;
	bool mode;
	float fireat2;
	float ax,ay;
	float time;
	BossEnemy()
	{
		data=3;
		data2=15;
		data3=.002;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		time=0;
	}
	BossEnemy(float R,float R2)
	{
		x=0;
		y=0;
		vx=0;
		vy=0;
		data=3;
		data2=25;
		data3=.03;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		rot2=R;
		r2=R2;
		nBoss2++;
		time=0;
	}
	void update()
	{
		if(BOSS==NULL)
		{
			dead=1;
			AddExplosion(x,y,r+r/2,1200);
			nBoss2--;
			return;
		}
		x=cos(rot2)*r2+BOSS->x;
		y=sin(rot2)*r2+BOSS->y;
#ifdef VERT
		if(y+r<-hh || x-r>hw || x+r<-hw) dead=1;
#else
		if(y+r<-hh || y-r>hh || x+r<-hw) dead=1;
#endif
		int i;
		if(data<3)
		{
			dead=1;
			if(nBoss>6 && nBoss%2==0)
				for(i=0;i<15;i++)
				{
					Health *bul=new Health((cos(pd[15]*i)*r)+x,(sin(pd[15]*i)*r)+y,cos(pd[15]*i)*2,sin(pd[15]*i)*2);
					AddObject(bul);
					Ebullet *bul2=new Ebullet((cos(pd[15]*i+rot)*r)+x,(sin(pd[15]*i+rot)*r)+y,cos(pd[15]*i+rot)*2,sin(pd[15]*i+rot)*2);
					AddObject(bul2);
				}
			else 
				for(i=0;i<15;i++)
				{
					Health *bul=new Health((cos(pd[15]*i)*r)+x,(sin(pd[15]*i)*r)+y,cos(pd[15]*i)*2,sin(pd[15]*i)*2);
					AddObject(bul);
				}
			AddExplosion(x,y,r+r/2,1200);
			score[0]+=2500;
			nBoss2--;
			Powerup(x,y);
			if(nBoss2<=0)
				BOSS->r-=15;
			return;
		}
		float c=1;//(data2-10)/20;
		if(blur)
			glDisable(GL_BLEND);
		else
			glEnable(GL_BLEND);
		glPushMatrix();
		glTranslatef(x,y,.8);
		glColor3f(c,0,0);
			glBegin(GL_TRIANGLE_FAN);
				glVertex2f(0,0);
				for(i=0;i<=data;i++)
				{
					glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
				}
			glEnd();
		glPopMatrix();
		glPushMatrix();
		glTranslatef(0,0,.4);
		glColor3f(c*.6,c*.6,c*.6);
		glBegin(GL_LINES);
			glVertex2f(x,y);
			glVertex2f(BOSS->x,BOSS->y);
		glEnd();
		glPopMatrix();
		if(nBoss%chanceSatelitesAim==0 && nBoss!=0)
		{
			if(fireat>data4)
			{
				mode=!mode;
			}
			else fireat+=fpsm;
			if(fireat2>data2)
			{
				if(mode)
				{
						if(player!=NULL)
						{
							float w=player->x-x;
							float h=player->y-y;
							float a=atan2(h,w);
							ax=cos(a);
							ay=sin(a);
						}
						else
						{
							float w=rand()%(int)width-hw-x;
							float h=rand()%(int)height-hh-y;
							float a=atan2(h,w);
							ax=cos(a);
							ay=sin(a);
						}
						Ebullet *bul=new Ebullet(-ay*r/2+x,ax*r/2+y,ax*3,ay*3);
						AddObject(bul);
						Ebullet *bul2=new Ebullet(ay*r/2+x,-ax*r/2+y,ax*3,ay*3);
						AddObject(bul2);
				}
				fireat2=0;
			}
			else fireat2+=fpsm;
		}
		else if(nBoss%chanceSatelitesShootCircles==0 && nBoss!=0)
		{
			if(fireat>data2/2)
			{
				EbulletBig *bul=new EbulletBig(x,y,(cos(rot))*2,(sin(rot))*2);
				AddObject(bul);
				EbulletBig *bul2=new EbulletBig(x,y,(cos(rot-M_PI))*2,(sin(rot-M_PI))*2);
				AddObject(bul2);
				fireat=0;
			}
			else fireat+=fpsm;
		}
		else if(nBoss%chanceSatelitesShootRockets==0 && nBoss!=0)
		{
			if(fireat>data2)
			{
				ERocket *bul=new ERocket(x,y);
				AddObject(bul);
				fireat=0;
			}
			else fireat+=fpsm;
		}
		else if(fireat>data2)
		{
			for(i=0;i<data4;i++)
			{
				Ebullet *bul=new Ebullet((cos(pd[data4]*i+rot+data3*1.5)*r)+x+cos(rot2*120),(sin(pd[data4]*i+rot+data3*1.5)*r)+y+sin(rot2*120),(cos(pd[data4]*i+rot+data3))*1.5,sin(pd[data4]*i+rot+data3)*1.5);
				AddObject(bul);
			}
			fireat=0;
		}
		else fireat+=fpsm;
		rot+=data3*fpsm;
		rot2+=data3*.3*fpsm;
		glColor3f(0,0,0);
		if(flash>=.1)
			flash-=fpsm;
		if(blur)
			glEnable(GL_BLEND);
		else
			glDisable(GL_BLEND);
		time+=fpsm;
		if(!dead) AddCircleToGrid(x,y,r,this);
	}
	void hit(Object *obj)
	{
		if(flash<.1)
		{
			if(obj->type==PBULLET)
			{
				if(obj->data==-7)
				{
					if(obj->data2>data)
					{
						obj->data2-=data;
						data=0;
					}
					else
					{
						data-=obj->data2;
						obj->data2=0;
					}
				}
				else
				{
					data--;
					obj->dead=1;
				}
				flash=5;
				score[obj->data4]+=100;
			}
			else
			{
				data=0;
			}		
		}
		else if(obj->type==PBULLET && obj->data!=-7) obj->dead=1;
	}
		
};
class Enemy:public Object
{
	public:
	float fireat;
	float rot;
	int dir;
	float time;
	Enemy()
	{
		data=3;
		data2=15;
		data3=.002;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		dir=rand()%2;
		time=-1000;
	}
	Enemy(int X,int Y,float VX,float VY)
	{
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		data=3;
		data2=25;
		data3=.03;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		time=-1000;
		dir=rand()%2;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
#ifdef VERT
		if(y<hh)
		{
			if(vy>.00001)
				vy-=.001*fpsm;
			else
			{
				if(time==-1000)
					time=rand()%200+100;
				else if(time>0) time-=fpsm;
				else
				{
					if(dir)
						vx-=.001*fpsm;
					else
						vx+=.001*fpsm;
				}
			}
		}
		if(y+r<-hh || x-r>hw || x+r<-hw) dead=1;
#else
		if(x<hw)
		{
			if(vx>.00001)
				vx-=.001*fpsm;
			else
			{
				if(time==-1000)
					time=rand()%200+100;
				else if(time>0) time-=fpsm;
				else
				{
					if(dir)
						vy-=.001*fpsm;
					else
						vy+=.001*fpsm;
				}
			}
		}
		if(y+r<-hh || y-r>hh || x+r<-hw) dead=1;
#endif
		int i;
		if(data<3)
		{
			dead=1;
			for(i=0;i<15;i++)
			{
				Health *bul=new Health((cos(pd[15]*i)*r)+x,(sin(pd[15]*i)*r)+y,cos(pd[15]*i)*2,sin(pd[15]*i)*2);
				AddObject(bul);
			}
			AddExplosion(x,y,r+r/2,1200);
			score[0]+=1000;
			Powerup(x,y);
			return;
		}
		float c=1;//(data2-10)/20;
		if(blur)
			glDisable(GL_BLEND);
		else
			glEnable(GL_BLEND);
		glPushMatrix();
		glTranslatef(x,y,.8);
		glColor3f(c*.2,c*.4,c*.8);
			glBegin(GL_TRIANGLE_FAN);
				glVertex2f(0,0);
				for(i=0;i<=data;i++)
				{
					glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
				}
			glEnd();
		glPopMatrix();
		if(BOSS==NULL)
		{
			if(fireat>data2)
			{
				for(i=0;i<data;i++)
				{
					Ebullet *bul=new Ebullet((cos(pd[data]*i+rot+data3*1.5)*r)+x+vx,(sin(pd[data]*i+rot+data3*1.5)*r)+y+vy,(cos(pd[data]*i+rot+data3))*1.5,sin(pd[data]*i+rot+data3)*1.5);
					AddObject(bul);
				}
				fireat=0;
			}
			else fireat+=fpsm;
		}
		else
		{
#ifdef VERT
			vx+=(x>0)?.1:-.1;
#else
			vy+=(y>0)?.1:-.1;
#endif
		}
		rot+=data3*fpsm;
		glColor3f(0,0,0);
		if(flash>=.1)
			flash-=fpsm;
		if(blur)
			glEnable(GL_BLEND);
		else
			glDisable(GL_BLEND);
		if(!dead) AddCircleToGrid(x,y,r,this);
	}
	void hit(Object *obj)
	{
		if(flash<.1)
		{
			if(obj->type==PBULLET)
			{
				if(obj->data==-7)
				{
					if(obj->data2>data)
					{
						obj->data2-=data;
						data=0;
					}
					else
					{
						data-=obj->data2;
						obj->data2=0;
					}
				}
				else
				{
					data--;
					obj->dead=1;
				}				
				flash=5;
				score[obj->data4]+=100;
			}
			else
			{
				data=0;
			}		
		}
		else if(obj->type==PBULLET && obj->data!=-7) obj->dead=1;
	}		
};
class AimEnemy:public Object
{
	public:
	float fireat;
	float fireat2;
	float rot;
	bool mode;
	float time;
	bool dir;
	float ax,ay;
	AimEnemy()
	{
		data=3;
		data2=15;
		data3=.002;
		data4=3;
		fireat=fireat2=0;
		type=ENEMY;
		flash=0;
		dir=rand()%2;
	}
	AimEnemy(int X,int Y,float VX,float VY)
	{
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		data=3;
		data2=40;
		data3=.05;
		data4=3;
		fireat=fireat2=0;
		type=ENEMY;
		flash=0;
		mode=1;
		time=-1000;
		dir=rand()%2;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
#ifdef VERT
		if(y<hh)
		{
			if(vy>.00001)
				vy-=.001*fpsm;
			else
			{
				if(time==-1000)
					time=rand()%200+100;
				else if(time>0) time-=fpsm;
				else
				{
					if(dir)
						vx-=.001*fpsm;
					else
						vx+=.001*fpsm;
				}
			}
		}
		if(y+r<-hh || x-r>hw || x+r<-hw) dead=1;
#else
		if(x<hw)
		{
			if(vx>.00001)
				vx-=.001*fpsm;
			else
			{
				if(time==-1000)
					time=rand()%200+100;
				else if(time>0) time-=fpsm;
				else
				{
					if(dir)
						vy-=.001*fpsm;
					else
						vy+=.001*fpsm;
				}
			}
		}
		if(y+r<-hh || y-r>hh || x+r<-hw) dead=1;
#endif
		int i;
		if(data<3)
		{
			dead=1;
			for(i=0;i<15;i++)
			{
				Health *bul=new Health((cos(pd[15]*i)*r)+x,(sin(pd[15]*i)*r)+y,cos(pd[15]*i)*2,sin(pd[15]*i)*2);
				AddObject(bul);
			}
			AddExplosion(x,y,r+r/2,1200);
			score[0]+=1000;
			Powerup(x,y);
			return;
		}
		float c=1;//(data2-10)/20;
		if(blur)
			glDisable(GL_BLEND);
		else
			glEnable(GL_BLEND);
		glPushMatrix();
		glTranslatef(x,y,.8);
		glColor3f(c*.9,c*.9,c*.2);
			glBegin(GL_TRIANGLE_FAN);
				glVertex2f(0,0);
				for(i=0;i<=data;i++)
				{
					glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
				}
			glEnd();
		glPopMatrix();
		rot+=data3*fpsm;
		if(fireat>data4)
		{
			mode=!mode;
		}
		else fireat+=fpsm;
		if(BOSS==NULL)
		{
			if(fireat2>data2)
			{
				if(mode)
				{
						if(player!=NULL)
						{
							float w=player->x-x;
							float h=player->y-y;
							float a=atan2(h,w);
							ax=cos(a);
							ay=sin(a);
						}
						else
						{
							float w=43-x;
							float h=-235-y;
							float a=atan2(h,w);
							ax=cos(a);
							ay=sin(a);
						}
						Ebullet *bul=new Ebullet(-ay*r/2+x,ax*r/2+y,ax*3,ay*3);
						AddObject(bul);
						Ebullet *bul2=new Ebullet(ay*r/2+x,-ax*r/2+y,ax*3,ay*3);
						AddObject(bul2);
				}
				fireat2=0;
			}
			else fireat2+=fpsm;
		}
		else
		{
			vx+=(x>0)?.1:-.1;
		}
		glColor3f(0,0,0);
		if(flash>=.1)
			flash-=fpsm;
		if(blur)
			glEnable(GL_BLEND);
		else
			glDisable(GL_BLEND);
		if(!dead) AddCircleToGrid(x,y,r,this);
	}
	void hit(Object *obj)
	{
		if(flash<.1)
		{
			if(obj->type==PBULLET)
			{
				if(obj->data==-7)
				{
					if(obj->data2>data)
					{
						obj->data2-=data;
						data=0;
					}
					else
					{
						data-=obj->data2;
						obj->data2=0;
					}
				}
				else
				{
					data--;
					obj->dead=1;
				}
				flash=5;
				score[obj->data4]+=150;
			}
			else
			{
				data=0;
			}		
		}
		else if(obj->type==PBULLET && obj->data!=-7) obj->dead=1;
	}
		
};
class ChargeEnemy:public Object
{
	public:
	float fireat;
	float rot;
	ChargeEnemy()
	{
		data=3;
		data2=15;
		data3=.002;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
	}
	ChargeEnemy(int X,int Y,float VX,float VY)
	{
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		data=3;
		data2=400;
		data3=.05;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
	}
	void update()
	{
		if(fireat<0)
		{
			x+=vx*fpsm;
			y+=vy*fpsm;
		}
#ifdef VERT
		if(y+r<-hh || x-r>hw || x+r<-hw) dead=1;
#else
		if(y+r<-hh || y-r>hh || x+r<-hw) dead=1;
#endif
		int i;
		if(data<3)
		{
			dead=1;
			for(i=0;i<15;i++)
			{
				Health *bul=new Health((cos(pd[15]*i)*r)+x,(sin(pd[15]*i)*r)+y,cos(pd[15]*i)*2,sin(pd[15]*i)*2);
				AddObject(bul);
				Ebullet *bul2=new Ebullet((cos(pd[15]*i+rot)*r)+x,(sin(pd[15]*i+rot)*r)+y,cos(pd[15]*i+rot)*2,sin(pd[15]*i+rot)*2);
				AddObject(bul2);
			}
			AddExplosion(x,y,r+r/2+r/2,1200);
			score[0]+=2000;
			Powerup(x,y);
			return;
		}
		float c=1;//(data2-10)/20;
		if(blur)
			glDisable(GL_BLEND);
		else
			glEnable(GL_BLEND);
		glPushMatrix();
		glTranslatef(x,y,.8);
		glColor3f(c,c*.1,c*.1);
			glBegin(GL_TRIANGLE_FAN);
				glVertex2f(0,0);
				for(i=0;i<=data;i++)
				{
					glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
				}
			glEnd();
		glPopMatrix();
		rot+=data3*fpsm;
		if(BOSS==NULL)
		{
			if(fireat>data2)
			{
				if(player!=NULL)
				{
					float w=player->x-x;
					float h=player->y-y;
					float a=atan2(h,w);
					vx=cos(a)*4;
					vy=sin(a)*4;
				}
				else
				{
					float w=rand()%(int)width-hw-x;
					float h=rand()%(int)height-hh-y;
					float a=atan2(h,w);
					vx=cos(a)*4;
					vy=sin(a)*4;
				}
				fireat=-data2;
			}
			else fireat+=fpsm;
		}
		else
		{
#ifdef VERT
			vx+=(x>0)?.1:-.1;
#else
			vy+=(y>0)?.1:-.1;
#endif
			fireat=-1;
		}
		glColor3f(0,0,0);
		if(flash>=.1)
			flash-=fpsm;
		if(blur)
			glEnable(GL_BLEND);
		else
			glDisable(GL_BLEND);
		if(!dead) AddCircleToGrid(x,y,r,this);
	}
	void hit(Object *obj)
	{
		if(flash<.1)
		{
			if(obj->type==PBULLET)
			{
				if(obj->data==-7)
				{
					if(obj->data2>data)
					{
						obj->data2-=data;
						data=0;
					}
					else
					{
						data-=obj->data2;
						obj->data2=0;
					}
				}
				else
				{
					data--;
					obj->dead=1;
				}
				flash=5;
				score[obj->data4]+=150;
			}
			else
			{
				data=0;
			}		
		}
		else if(obj->type==PBULLET && obj->data!=-7) obj->dead=1;
	}
		
};
class SpurtEnemy:public Object
{
	public:
	float fireat;
	float rot;
	int dir;
	float time;
	SpurtEnemy()
	{
		data=3;
		data2=15;
		data3=.002;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		dir=rand()%2;
		time=-1000;
	}
	SpurtEnemy(int X,int Y,float VX,float VY)
	{
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		data=3;
		data2=25;
		data3=.03;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		time=-1000;
		dir=rand()%2;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
#ifdef VERT
		if(y<hh)
		{
			if(vy>.00001)
				vy-=.001*fpsm;
			else
			{
				if(time==-1000)
					time=rand()%200+100;
				else if(time>0) time-=fpsm;
				else
				{
					if(dir)
						vx-=.001*fpsm;
					else
						vx+=.001*fpsm;
				}
			}
		}
		if(y+r<-hh || x-r>hw || x+r<-hw) dead=1;
#else
		if(x<hw)
		{
			if(vx>.00001)
				vx-=.001*fpsm;
			else
			{
				if(time==-1000)
					time=rand()%200+100;
				else if(time>0) time-=fpsm;
				else
				{
					if(dir)
						vy-=.001*fpsm;
					else
						vy+=.001*fpsm;
				}
			}
		}
		if(y+r<-hh || y-r>hh || x+r<-hw) dead=1;
#endif
		int i;
		if(data<3)
		{
			dead=1;
			for(i=0;i<15;i++)
			{
				Health *bul=new Health((cos(pd[15]*i)*r)+x,(sin(pd[15]*i)*r)+y,cos(pd[15]*i)*2,sin(pd[15]*i)*2);
				AddObject(bul);
			}
			AddExplosion(x,y,r+r/2,1200);
			score[0]+=1000;
			Powerup(x,y);
			return;
		}
		float c=1;//(data2-10)/20;
		if(blur)
			glDisable(GL_BLEND);
		else
			glEnable(GL_BLEND);
		glPushMatrix();
		glTranslatef(x,y,.8);
		glColor3f(0,c*.9,c*.1);
			glBegin(GL_TRIANGLE_FAN);
				glVertex2f(0,0);
				for(i=0;i<=data;i++)
				{
					glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
				}
			glEnd();
		glPopMatrix();
		if(BOSS==NULL)
		{
			if(fireat>data2)
			{
				EbulletBig *bul=new EbulletBig(x,y,(cos(rot))*2,(sin(rot))*2);
				AddObject(bul);
				EbulletBig *bul2=new EbulletBig(x,y,(cos(rot-M_PI))*2,(sin(rot-M_PI))*2);
				AddObject(bul2);
				fireat=0;
			}
			else fireat+=fpsm;
		}
		else
		{
#ifdef VERT
			vx+=(x>0)?.1:-.1;
#else
			vy+=(y>0)?.1:-.1;
#endif
		}
		rot+=data3*fpsm;
		glColor3f(0,0,0);
		if(flash>=.1)
			flash-=fpsm;
		if(blur)
			glEnable(GL_BLEND);
		else
			glDisable(GL_BLEND);
		if(!dead) AddCircleToGrid(x,y,r,this);
	}
	void hit(Object *obj)
	{
		if(flash<.1)
		{
			if(obj->type==PBULLET)
			{
				if(obj->data==-7)
				{
					if(obj->data2>data)
					{
						obj->data2-=data;
						data=0;
					}
					else
					{
						data-=obj->data2;
						obj->data2=0;
					}
				}
				else
				{
					data--;
					obj->dead=1;
				}
				flash=5;
				score[obj->data4]+=100;
			}
			else
			{
				data=0;
			}		
		}
		else if(obj->type==PBULLET && obj->data!=-7) obj->dead=1;
	}
		
};
class RocketEnemy:public Object
{
	public:
	float fireat;
	float rot;
	int dir;
	float time;
	RocketEnemy()
	{
		data=3;
		data2=15;
		data3=.002;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		dir=rand()%2;
		time=-1000;
	}
	RocketEnemy(int X,int Y,float VX,float VY)
	{
		x=X;
		y=Y;
		vx=VX;
		vy=VY;
		data=3;
		data2=25;
		data3=.03;
		data4=3;
		fireat=0;
		type=ENEMY;
		flash=0;
		time=-1000;
		dir=rand()%2;
	}
	void update()
	{
		x+=vx*fpsm;
		y+=vy*fpsm;
#ifdef VERT
		if(y<hh)
		{
			if(vy>.00001)
				vy-=.001*fpsm;
			else
			{
				if(time==-1000)
					time=rand()%200+100;
				else if(time>0) time-=fpsm;
				else
				{
					if(dir)
						vx-=.001*fpsm;
					else
						vx+=.001*fpsm;
				}
			}
		}
		if(y+r<-hh || x-r>hw || x+r<-hw) dead=1;
#else
		if(x<hw)
		{
			if(vx>.00001)
				vx-=.001*fpsm;
			else
			{
				if(time==-1000)
					time=rand()%200+100;
				else if(time>0) time-=fpsm;
				else
				{
					if(dir)
						vy-=.001*fpsm;
					else
						vy+=.001*fpsm;
				}
			}
		}
		if(y+r<-hh || y-r>hh || x+r<-hw) dead=1;
#endif
		int i;
		if(data<3)
		{
			dead=1;
			for(i=0;i<15;i++)
			{
				Health *bul=new Health((cos(pd[15]*i)*r)+x,(sin(pd[15]*i)*r)+y,cos(pd[15]*i)*2,sin(pd[15]*i)*2);
				AddObject(bul);
			}
			AddExplosion(x,y,r+r/2,1200);
			score[0]+=1500;
			Powerup(x,y);
			return;
		}
		float c=1;//(data2-10)/20;
		if(blur)
			glDisable(GL_BLEND);
		else
			glEnable(GL_BLEND);
		glPushMatrix();
		glTranslatef(x,y,2);
		glColor3f(c,c*.6,0);
			glBegin(GL_TRIANGLE_FAN);
				glVertex2f(0,0);
				for(i=0;i<=data;i++)
				{
					glVertex2f((cos(pd[data]*i+rot)*r),(sin(pd[data]*i+rot)*r));
				}
			glEnd();
		glPopMatrix();
		if(BOSS==NULL)
		{
			if(fireat>data2)
			{
				ERocket *bul=new ERocket(x,y);
				AddObject(bul);
				fireat=0;
			}
			else fireat+=fpsm;
		}
		else
		{
#ifdef VERT
			vx+=(x>0)?.1:-.1;
#else
			vy+=(y>0)?.1:-.1;
#endif
		}
		rot+=data3*fpsm;
		glColor3f(0,0,0);
		if(flash>=.1)
			flash-=fpsm;
		if(blur)
			glEnable(GL_BLEND);
		else
			glDisable(GL_BLEND);
		if(!dead) AddCircleToGrid(x,y,r,this);
	}
	void hit(Object *obj)
	{
		if(flash<.1)
		{
			if(obj->type==PBULLET)
			{
				if(obj->data==-7)
				{
					if(obj->data2>data)
					{
						obj->data2-=data;
						data=0;
					}
					else
					{
						data-=obj->data2;
						obj->data2=0;
					}
				}
				else
				{
					data--;
					obj->dead=1;
				}
				flash=5;
				score[obj->data4]+=100;
			}
			else
			{
				data=0;
			}		
		}
		else if(obj->type==PBULLET && obj->data!=-7) obj->dead=1;
	}
};
void UpdateObject()
{
	Object* thisObject=firstObject;
	while(thisObject!=NULL)
	{
		thisObject=thisObject->next;
	}
}
void ChangeSize(int w, int h)
{
	if(h == 0)
		h=1;
    glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-w/2,w/2,-h/2,h/2,-100,100);
	hw=w/2;
	hh=h/2;
	qw=w/4;
	qh=h/4;
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	width=w;
	height=h;
	CW=width/GW;
	CH=height/GH;
}
void ChangeSizeProj(int w, int h)
{
	if(h == 0)
		h=1;
    glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-w/2,w/2,-h/2,h/2,1,100);
	hw=w/2;
	hh=h/2;
	qw=w/4;
	qh=h/4;
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	width=w;
	height=h;
}
int preDraw()
{
	glClearColor(0.0f, 0.0, 0.0, 1.0);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	return 1;
}
float total=0,di=1;
float fpS=0,Fps=0;
int postDraw()
{
	SDL_GL_SwapBuffers();
	int currentTime=SDL_GetTicks();
	if ((currentTime-start)>=1)
	{
		FPS=currentTime-start;
		char fps[50];
#ifdef DEBUG
		sprintf(fps,"OBJECTS: %i  MS/F: %f  FPS: %f",nObject,fpS,Fps);
#else
		sprintf(fps,"ZALLAN  (FPS: %f)",Fps);
#endif
		if(di>150/fpsm) 
		{
			fpS=total/di;
			di=1;
			total=0;
			Fps=1000.f/fpS;
		}
		total+=FPS;
		di+=1;
		SDL_WM_SetCaption(fps,NULL);
		frames=0;
		start=currentTime;
		Uint8 * keystate=SDL_GetKeyState(NULL);
#ifdef DEBUG
		if(!keystate[SDLK_f])
#endif
			fpsm=FPS/(float)(1000.f/60.f);
#ifdef DEBUG
		else
			fpsm=5;
#endif
	}
	return 1;
}
float q = .85;

int rn=0;
int d=0;
void debug()
{
#ifdef DEBUG
	FILE *fp;
	fp=fopen("debug.txt","w");
	fprintf(fp,"%i\n",d);
	fclose(fp);
	d++;
#endif
}
int playerAtTop()
{
	if(player!=NULL)
#ifdef VERT
		if(player->y>hh-150 && player->gun==2)
#else
		if(player->x>hw-150 && player->gun==2)
#endif
			return 1;
	if(player2!=NULL)
#ifdef VERT
		if(player2->y>hh-150 && player2->gun==2)
#else
		if(player2->x>hw-150 && player2->gun==2)
#endif
			return 1;	
	return 0;
}
void Render()
{
	if(paused) return;
	for(int j=0;j<GH;j++)
		for(int i=0;i<GW;i++)
			grid[i][j].Clear();
	if(score[0]>highscore && player!=NULL) highscore=score[0];
	if(score[1]>highscore) highscore=score[1];
	preDraw();	
	ChangeSizeProj(width,height);
	float color=.15;
	glColor3f(color,color,color);
	glPushMatrix();
#ifdef VERT
	glTranslatef(0,-dist*10,-10);
#else
	glTranslatef(-dist*10,0,-10);
#endif
	glBegin(GL_LINES);
		for(float y=-hh*10;y<(hh+100)*10;y+=80*10)
		{
			glVertex2f(-hw*10,y);
			glVertex2f((hw+100)*10,y);
		}
		for(float x=-hw*10;x<(hw+100)*10;x+=80*10)
		{
			glVertex2f(x,-hh*10);
			glVertex2f(x,(hh+100)*10);
		}
	glEnd();
	glDisable(GL_BLEND);
	glBegin(GL_LINES);
	for(float y=-hh*20;y<(hh+100)*20;y+=80*10)
		for(float x=-hw*20;x<(hw+100)*20;x+=80*10)
		{				
			glColor3f(color,color,color);
			glVertex3f(x,y,0);
			glColor3f(0,0,0);
			glVertex3f(x,y,-20);
		}
	glEnd();
	glEnable(GL_BLEND);
	glPopMatrix();	
	ChangeSize(width,height);
	UpdateObjects();
	for(int j=0;j<GH;j++)
		for(int i=0;i<GW;i++)
		{
			LL* thisLL=grid[i][j].first;
			while(thisLL!=NULL)
			{
				LL* thatLL=thisLL->next;
				while(thatLL!=NULL)
				{
					switch(collisiontable[thatLL->obj->type][thisLL->obj->type])
					{
						case P2C:
							if(point2Circle(thisLL->obj->x,thisLL->obj->y,thisLL->obj->r,thatLL->obj->x,thatLL->obj->y))
								thisLL->obj->hit(thatLL->obj);
							break;
						case C2P:
							if(point2Circle(thisLL->obj->x,thisLL->obj->y,thisLL->obj->r,thatLL->obj->x,thatLL->obj->y))
								thisLL->obj->hit(thatLL->obj);
							break;
						case C2C:
							if(cicle2Circle(thisLL->obj->x,thisLL->obj->y,thisLL->obj->r,thatLL->obj->x,thatLL->obj->y,thatLL->obj->r))
							{
								thatLL->obj->hit(thisLL->obj);
								thisLL->obj->hit(thatLL->obj);
							}
							break;
						case P2T:
							if(point2Circle(thisLL->obj->x,thisLL->obj->y,thisLL->obj->r,thatLL->obj->x,thatLL->obj->y))
								if(point2Triangle((vec2f){thatLL->obj->x,thatLL->obj->y},(vec2f){thisLL->obj->x,thisLL->obj->y+10},(vec2f){thisLL->obj->x-7,thisLL->obj->y-8},(vec2f){thisLL->obj->x+7,thisLL->obj->y-8}))
									thisLL->obj->hit(thatLL->obj);
							break;
						case T2P:
							if(point2Circle(thisLL->obj->x,thisLL->obj->y,thisLL->obj->r,thatLL->obj->x,thatLL->obj->y))
								if(point2Triangle((vec2f){thisLL->obj->x,thisLL->obj->y},(vec2f){thatLL->obj->x,thatLL->obj->y+10},(vec2f){thatLL->obj->x-7,thatLL->obj->y-8},(vec2f){thatLL->obj->x+7,thatLL->obj->y-8}))
									thatLL->obj->hit(thisLL->obj);
							break;	
					}
					thatLL=thatLL->next;
				}
				thisLL=thisLL->next;	
			}
		}
	glDisable(GL_POLYGON_SMOOTH);
	for(int i=0;i<MAX_BOOM;i++)
		boom[i].update();
	dist+=2*fpsm;
	if(dist>=80)
	{
		dist=0;
		td++;
	}
	glFontBegin(font);
	char str[20];
	glColor3f(1,1,1);
	sprintf(str,"%i",score[0]);
	glTranslatef(-hw,hh,5);
	glScalef(10,10,1);
	glFontTextOut(str);
	glFontEnd();
	glScalef(.1,.1,1);
	glTranslatef(0,-35,0);
	glColor3f(.7,.7,.7);
	glBegin(GL_TRIANGLES);
	int x=8;
		for(int i=0;i<lives;i++,x+=16)
		{
			glVertex2f(x,10);
			glVertex2f(x-7,-8);
			glVertex2f(x+7,-8);
		}
	glEnd();
	glLoadIdentity();
	glColor3f(1,1,1);
	if(player2==NULL)
	{
		glPushMatrix();
		glFontBegin(font);
		sprintf(str,"%i",highscore);
		glTranslatef(hw,hh,5);
		glScalef(10,10,1);
		glFontTextOutr(str);
		glFontEnd();
		glPopMatrix();
	}
	else
	{
		glPushMatrix();
		glFontBegin(font);
		sprintf(str,"%i",score[1]);
		glTranslatef(hw,hh,5);
		glScalef(10,10,1);
		glFontTextOutr(str);
		glFontEnd();
		glPopMatrix();
	}
#ifdef DEBUG
	glPushMatrix();
		glFontBegin(font);
		sprintf(str,"%i",boss);
		glTranslatef(0,hh,5);
		glScalef(5,5,1);
		glFontTextOutr(str);
		glFontEnd();
	glPopMatrix();
#endif
	glLoadIdentity();
	glTranslatef(0,0,5);
	if(player!=NULL)
	{
		glBegin(GL_TRIANGLE_STRIP);
			glColor3f(.1,1,.2);
			glVertex2f(-hw+2,-hh+2);
			glVertex2f(-hw+17,-hh+2);
			glVertex2f(-hw+2,-hh+2+player->data);
			glVertex2f(-hw+17,-hh+2+player->data);
		glEnd();
	}
	glColor3f(1,1,1);
	glBegin(GL_LINE_LOOP);
		glVertex2f(-hw+2,-hh+2);
		glVertex2f(-hw+2,-hh+202);
		glVertex2f(-hw+17,-hh+202);
		glVertex2f(-hw+17,-hh+2);
	glEnd();		
	for(int i=0;i<nAnim;i++)
	{
		anim[i]->update();
	}
	glEnable(GL_POLYGON_SMOOTH);
	postDraw();
	if(rn<=0)
	{
		if(player2==NULL)
			rn=(rand()%timeBetweenEnemies-nBoss)/fpsm;
		else
			rn=(rand()%timeBetweenEnemies/2-nBoss)/fpsm;
		if(BOSS!=NULL) return;
		if(boss>timeBeforeBoss+nBoss && player!=NULL)
		{
				BOSS=new Boss();
				BOSS->r=bossRadius+15;
				BOSS->data=min(max(nBoss*50,bossMinSides),400);
				BOSS->data2=bossFireRate;
				BOSS->data4=min(maxBossBullets,nBoss*10+10);
				AddObject(BOSS);
				int n=min(nBoss+bossStartingSatelites,15);
				for(int i=0;i<n;i++)
				{
					BossEnemy *b=new BossEnemy(pd[n]*i,distOfSatelitesfromBoss);
					b->r=sateliteRadius;
					b->data2=sateliteFireRate;
					b->data=min(max(nBoss*5,minSateliteSides),maxSateliteSides);
					b->data4=min(b->data,maxSateliteBullets);
					AddObject(b);
				}
				boss=0;
		}
		else
			boss++;
		if(BOSS!=NULL) return;
		if(td>timeBeforeAimingEnemy)
		{
			if(rand()%chanceOfAimingEnemy==0)
			{
#ifdef VERT
				AimEnemy *enemy=new AimEnemy(rand()%400-200,hh+100,0,-(rand()%4*.1+.4));
#else
				AimEnemy *enemy=new AimEnemy(hw+100,rand()%400-200,-(rand()%4*.1+.4),0);
#endif
				enemy->r=rand()%aimingEnemyMaxAddedRadius+aimingEnemyMinRadius;
				enemy->data=rand()%aimingEnemyMaxAddedSides+aimingEnemyMinSides+nBoss*1.5;
				enemy->data2=aimingEnemyFireRate;
				enemy->data4=rand()%aimingEnemyMaxAddedFireTime+aimingEnemyMinFireTime;
				AddObject(enemy);
				return;
			}
		}
		
		if(td>timeBeforeCircleEnemy)
		{
			if(rand()%chanceOfCircleEnemy==0)
			{
#ifdef VERT
				SpurtEnemy *enemy=new SpurtEnemy(rand()%400-200,hh+100,0,-(rand()%4*.1+.4));
#else
				SpurtEnemy *enemy=new SpurtEnemy(hw+100,rand()%400-200,-(rand()%4*.1+.4),0);
#endif
				enemy->r=rand()%circleEnemyMaxAddedRadius+circleEnemyMinRadius;
				enemy->data=rand()%circleEnemyMaxAddedSides+circleEnemyMinSides+nBoss*1.5;
				enemy->data2=rand()%circleEnemyMaxAddedFireRate+circleEnemyMinFireRate-nBoss*1.5;
				AddObject(enemy);
				return;
			}
		}
		if(td>timeBeforeChargingEnemy)
		{
			if(rand()%chanceOfChargingEnemy==0)
			{
#ifdef VERT
				ChargeEnemy *enemy=new ChargeEnemy(rand()%400-200,hh+100,0,-(rand()%4*.1+.4));
#else
				ChargeEnemy *enemy=new ChargeEnemy(hw+100,rand()%400-200,-(rand()%4*.1+.4),0);
#endif
				enemy->r=rand()%chargingEnemyMaxAddedRadius+chargingEnemyMinRadius;
				enemy->data=rand()%chargingEnemyMaxAddedSides+chargingEnemyMinSides+nBoss*1.5;
				enemy->data2=rand()%chargingEnemyMaxAddedRate+chargingEnemyMinRate-nBoss*1.5;
				AddObject(enemy);
				return;
			}
		}
		if(td>timeBeforeRocketEnemy)
		{
			if(rand()%chanceOfRocketEnemy==0 || (playerAtTop() && rand()%(chanceOfRocketEnemy/3)))//playerAtTop() is used to make sure players arent "cheating" and just staying in one place near the top
			{				
#ifdef VERT
				RocketEnemy *enemy=new RocketEnemy(rand()%400-200,hh+100,0,-(rand()%4*.1+.4));
#else
				RocketEnemy *enemy=new RocketEnemy(hw+100,rand()%400-200,-(rand()%4*.1+.4),0);
#endif
				enemy->r=rand()%rocketEnemyMaxAddedRadius+rocketEnemyMinRadius;
				enemy->data=rand()%rocketEnemyMaxAddedSides+rocketEnemyMinSides;
				enemy->data2=rand()%rocketEnemyMaxAddedFireRate+rocketEnemyMinFireRate;
				AddObject(enemy);
				return;
			}
		}
#ifdef VERT
		Enemy *enemy=new Enemy(rand()%400-200,hh+100,0,-(rand()%4*.1+.4));
#else
		Enemy *enemy=new Enemy(hw+100,rand()%400-200,-(rand()%4*.1+.4),0);
#endif
		enemy->r=rand()%enemyMaxAddedRadius+enemyMinRadius;
		enemy->data=rand()%enemyMaxAddedSides+enemyMinSides;
		enemy->data2=rand()%enemyMaxAddedFireRate+enemyMinFireRate;
		AddObject(enemy);
	}
	rn--;
}
int Init(int argc, char* argv[],char *windowname)
{
	FILE *fp;
	debug();
	if((fp=fopen("highscore.txt","r"))!=NULL)
	{
		fscanf(fp,"highscore: %i\n",&highscore);
		fscanf(fp,"vsync: %i\n",&vsync);
		fscanf(fp,"sound: %i\n",&sound);
		fclose(fp);
	}
	else highscore=0;
	atexit(Savehighscore);
	if((fp=fopen("level.txt","r"))==NULL)
	{
		printf("ERROR LOADING LEVEL, USING DEFAULTS!\n");
	}
	else
	{
		fscanf(fp,"timeBetweenEnemies=%i\n",&timeBetweenEnemies);
		fscanf(fp,"lifeBarRate=%f\n",&lifeBarRate);
		fscanf(fp,"randomNumberSeed=%i\n",&randomNumberSeed);
		fscanf(fp,"powerUpAtMultipleOf=%i\n\n",&powerUpAtMultipleOf);

		fscanf(fp,"timeBeforeBoss=%i\n",&timeBeforeBoss);
		fscanf(fp,"bossRadius=%i\n",&bossRadius);
		fscanf(fp,"bossMinSides=%i\n",&bossMinSides);
		fscanf(fp,"bossFireRate=%i\n",&bossFireRate);
		fscanf(fp,"maxBossBullets=%i\n",&maxBossBullets);
		fscanf(fp,"bossStartingSatelites=%i\n",&bossStartingSatelites);
		fscanf(fp,"distOfSatelitesfromBoss=%i\n",&distOfSatelitesfromBoss);
		fscanf(fp,"sateliteRadius=%i\n",&sateliteRadius);
		fscanf(fp,"sateliteFireRate=%i\n",&sateliteFireRate);
		fscanf(fp,"minSateliteSides=%i\n",&minSateliteSides);
		fscanf(fp,"maxSateliteSides=%i\n",&maxSateliteSides);
		fscanf(fp,"maxSateliteBullets=%i\n",&maxSateliteBullets);
		fscanf(fp,"chanceSatelitesAim=%i\n",&chanceSatelitesAim);
		fscanf(fp,"chanceSatelitesShootCircles=%i\n",&chanceSatelitesShootCircles);
		fscanf(fp,"chanceSatelitesShootRockets=%i\n\n",&chanceSatelitesShootRockets);

		fscanf(fp,"enemyMinRadius=%i\n",&enemyMinRadius);
		fscanf(fp,"enemyMaxAddedRadius=%i\n",&enemyMaxAddedRadius);
		fscanf(fp,"enemyMinSides=%i\n",&enemyMinSides);
		fscanf(fp,"enemyMaxAddedSides=%i\n",&enemyMaxAddedSides);
		fscanf(fp,"enemyMinFireRate=%i\n",&enemyMinFireRate);
		fscanf(fp,"enemyMaxAddedFireRate=%i\n\n",&enemyMaxAddedFireRate);

		fscanf(fp,"timeBeforeAimingEnemy=%i\n",&timeBeforeAimingEnemy);
		fscanf(fp,"chanceOfAimingEnemy=%i\n",&chanceOfAimingEnemy);
		fscanf(fp,"aimingEnemyMinRadius=%i\n",&aimingEnemyMinRadius);
		fscanf(fp,"aimingEnemyMaxAddedRadius=%i\n",&aimingEnemyMaxAddedRadius);
		fscanf(fp,"aimingEnemyMinSides=%i\n",&aimingEnemyMinSides);
		fscanf(fp,"aimingEnemyMaxAddedSides=%i\n",&aimingEnemyMaxAddedSides);
		fscanf(fp,"aimingEnemyFireRate=%i\n",&aimingEnemyFireRate);
		fscanf(fp,"aimingEnemyMinFireTime=%i\n",&aimingEnemyMinFireTime);
		fscanf(fp,"aimingEnemyMaxAddedFireTime=%i\n\n",&aimingEnemyMaxAddedFireTime);

		fscanf(fp,"timeBeforeCircleEnemy=%i\n",&timeBeforeCircleEnemy);
		fscanf(fp,"chanceOfCircleEnemy=%i\n",&chanceOfCircleEnemy);
		fscanf(fp,"circleEnemyMinRadius=%i\n",&circleEnemyMinRadius);
		fscanf(fp,"circleEnemyMaxAddedRadius=%i\n",&circleEnemyMaxAddedRadius);
		fscanf(fp,"circleEnemyMinSides=%i\n",&circleEnemyMinSides);
		fscanf(fp,"circleEnemyMaxAddedSides=%i\n",&circleEnemyMaxAddedSides);
		fscanf(fp,"circleEnemyMinFireRate=%i\n",&circleEnemyMinFireRate);
		fscanf(fp,"circleEnemyMaxAddedFireRate=%i\n",&circleEnemyMaxAddedFireRate);
		fscanf(fp,"circleBulletRadius=%i\n\n",&circleBulletRadius);

		fscanf(fp,"timeBeforeChargingEnemy=%i\n",&timeBeforeChargingEnemy);
		fscanf(fp,"chanceOfChargingEnemy=%i\n",&chanceOfChargingEnemy);
		fscanf(fp,"chargingEnemyMinRadius=%i\n",&chargingEnemyMinRadius);
		fscanf(fp,"chargingEnemyMaxAddedRadius=%i\n",&chargingEnemyMaxAddedRadius);
		fscanf(fp,"chargingEnemyMinSides=%i\n",&chargingEnemyMinSides);
		fscanf(fp,"chargingEnemyMaxAddedSides=%i\n",&chargingEnemyMaxAddedSides);
		fscanf(fp,"chargingEnemyMinRate=%i\n",&chargingEnemyMinRate);
		fscanf(fp,"chargingEnemyMaxAddedRate=%i\n\n",&chargingEnemyMaxAddedRate);

		fscanf(fp,"timeBeforeRocketEnemy=%i\n",&timeBeforeRocketEnemy);
		fscanf(fp,"chanceOfRocketEnemy=%i\n",&chanceOfRocketEnemy);
		fscanf(fp,"rocketEnemyMinRadius=%i\n",&rocketEnemyMinRadius);
		fscanf(fp,"rocketEnemyMaxAddedRadius=%i\n",&rocketEnemyMaxAddedRadius);
		fscanf(fp,"rocketEnemyMinSides=%i\n",&rocketEnemyMinSides);
		fscanf(fp,"rocketEnemyMaxAddedSides=%i\n",&rocketEnemyMaxAddedSides);
		fscanf(fp,"rocketEnemyMinFireRate=%i\n",&rocketEnemyMinFireRate);
		fscanf(fp,"rocketEnemyMaxAddedFireRate=%i\n",&rocketEnemyMaxAddedFireRate);		
		fscanf(fp,"rocketSpeed=%i\n",&rocketSpeed);
		fscanf(fp,"timeTillRocketExplodes=%i\n",&timeTillRocketExplodes);
	}
	fclose(fp);
	debug();
	srand(randomNumberSeed);
	powerup[0]=powerup[1]=0;
	poweruptype[0]=poweruptype[1]=0;
	powerupat[0]=powerupat[1]=powerUpAtMultipleOf;
	debug();
	SDL_Init(SDL_INIT_EVERYTHING);
	SDL_GL_SetAttribute(SDL_GL_SWAP_CONTROL,vsync) ;//V sinc
	debug();
#ifdef VERT
	SDL_SetVideoMode(480,800,24,SDL_OPENGL|SDL_DOUBLEBUF);
	debug();
	ChangeSize(480,800);
#else
	SDL_SetVideoMode(800,480,24,SDL_OPENGL|SDL_DOUBLEBUF);
	ChangeSize(800,480);	
#endif
	debug();
	Mix_OpenAudio(44100, AUDIO_S16, MIX_DEFAULT_CHANNELS,4096);
	debug();
	/*if(sound)
	{
		Mix_Volume(-1, MIX_MAX_VOLUME/2);
		Mix_VolumeMusic(MIX_MAX_VOLUME);
	}
	else
	{
		Mix_Volume(-1, 0);
		Mix_VolumeMusic(0);
	}*/
		Mix_VolumeMusic(MIX_MAX_VOLUME);
	debug();
	music=Mix_LoadMUS("music1.xm");
	debug();
	bam=Mix_LoadWAV("boom.wav");
	gotpowerup=Mix_LoadWAV("powerup.wav");
	shoot[0]=Mix_LoadWAV("shoot1.wav");
	shoot[1]=Mix_LoadWAV("shoot2.wav");
	shoot[2]=Mix_LoadWAV("shoot3.wav");
	select=Mix_LoadWAV("selectmove.wav");
	debug();
	Mix_PlayMusic(music,-1);
	glPolygonMode(GL_FRONT,GL_FILL);
	glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
	glEnable(GL_DEPTH_TEST);
	glPointSize(2);
	glLineWidth(1.1);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_POLYGON_SMOOTH);
	glEnable(GL_BLEND);
	glEnable(GL_LINE_SMOOTH);
	glEnable(GL_POINT_SMOOTH);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);
	glHint(GL_POLYGON_SMOOTH, GL_NICEST);
	glHint(GL_LINE_SMOOTH, GL_NICEST);
	glHint(GL_POINT_SMOOTH, GL_NICEST);
	for(int i=2;i<500;i++)
	{
		pd[i]=(M_PI*2)/i;
	}
	Menu *menu=new Menu();
	AddAnimation(menu);
	glClearColor(0.0f, 0.0, 0.0, 1.0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glGenTextures(1,&fontID);
	font=glFontCreate("font.fnt",fontID);
	player=NULL;
}

int Run()
{
	while(!quit)
	{
		Render();
		SDL_Event ev;
		while(SDL_PollEvent(&ev))
		{
			switch(ev.type)
			{
				case SDL_KEYDOWN:
					switch(ev.key.keysym.sym)
					{
						case SDLK_ESCAPE:
							quit=1;
							break;
						case SDLK_p:
							paused=!paused;
							break;
					}
					break;
			}
		}
		Uint8 * keystate=SDL_GetKeyState(NULL);
	}
	return 1;
}

int Quit()
{
	return 0;
}

int main(int argc, char *argv[])
{
	Init(argc,argv,"FPS: 60");
	Run();
	Quit();
}
